"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderParamsCodec = exports.TransferParamsCodec = exports.NonNegativeBigNumber = exports.PositiveBigNumber = exports.BigNumberT = exports.BigNumberCodec = exports.MintV2BodyCodec = exports.MintUserCodec = exports.MintFeeCodec = exports.MintBodyCodec = exports.TokenCodec = exports.TokenTypeCodec = exports.MintableERC721TokenCodec = exports.MintableERC721TokenTypeT = exports.MintableERC721TokenType = exports.MintableERC20TokenCodec = exports.MintableERC20TokenTypeT = exports.MintableERC20TokenType = exports.ERC721TokenCodec = exports.ERC721TokenTypeT = exports.ERC721TokenType = exports.ERC20TokenCodec = exports.ERC20TokenTypeT = exports.ERC20TokenType = exports.ETHTokenCodec = exports.ETHTokenTypeT = exports.ETHTokenType = exports.fromEnum = exports.PositiveIntegerC = exports.PositiveNumberStringC = exports.PositiveIntegerStringC = exports.IntegerString = exports.HexadecimalString = exports.NumberString = exports.EthAddress = void 0;
var address_1 = require("@ethersproject/address");
var bignumber_1 = require("@ethersproject/bignumber");
var E = __importStar(require("fp-ts/Either"));
var function_1 = require("fp-ts/function");
var t = __importStar(require("io-ts"));
var io_ts_types_1 = require("io-ts-types");
exports.EthAddress = t.brand(t.string, function (s) { return address_1.isAddress(s); }, 'EthAddress');
exports.NumberString = t.brand(t.string, function (s) { return s !== '' && !isNaN(s); }, 'NumberString');
exports.HexadecimalString = t.brand(t.string, function (s) { return typeof s === 'string' && s.substring(0, 2) === '0x'; }, 'HexadecimalString');
exports.IntegerString = t.brand(exports.NumberString, function (s) { return Number.isInteger(parseFloat(s)); }, 'IntegerString');
exports.PositiveIntegerStringC = t.brand(exports.NumberString, function (s) {
    return Number.isInteger(parseFloat(s)) && parseFloat(s) > 0;
}, 'PositiveIntegerString');
exports.PositiveNumberStringC = t.brand(exports.NumberString, function (s) { return parseFloat(s) > 0; }, 'PositiveNumberString');
exports.PositiveIntegerC = t.brand(t.number, function (n) { return Number.isInteger(n) && n > 0; }, 'PositiveInteger');
function fromEnum(enumName, theEnum) {
    var isEnumValue = function (input) { return Object.values(theEnum).includes(input); };
    return new t.Type(enumName, isEnumValue, function (input, context) { return (isEnumValue(input) ? t.success(input) : t.failure(input, context)); }, t.identity);
}
exports.fromEnum = fromEnum;
/**
 * Token(s)
 */
var ETHTokenType;
(function (ETHTokenType) {
    ETHTokenType["ETH"] = "ETH";
})(ETHTokenType = exports.ETHTokenType || (exports.ETHTokenType = {}));
exports.ETHTokenTypeT = fromEnum('ETHTokenType', ETHTokenType);
exports.ETHTokenCodec = t.interface({
    type: exports.ETHTokenTypeT,
    data: t.interface({
        decimals: t.number,
    }),
});
var ERC20TokenType;
(function (ERC20TokenType) {
    ERC20TokenType["ERC20"] = "ERC20";
})(ERC20TokenType = exports.ERC20TokenType || (exports.ERC20TokenType = {}));
exports.ERC20TokenTypeT = fromEnum('ERC20TokenType', ERC20TokenType);
exports.ERC20TokenCodec = t.interface({
    type: exports.ERC20TokenTypeT,
    data: t.interface({
        symbol: t.string,
        decimals: t.number,
        tokenAddress: exports.EthAddress,
    }),
});
var ERC721TokenType;
(function (ERC721TokenType) {
    ERC721TokenType["ERC721"] = "ERC721";
})(ERC721TokenType = exports.ERC721TokenType || (exports.ERC721TokenType = {}));
exports.ERC721TokenTypeT = fromEnum('ERC721TokenType', ERC721TokenType);
exports.ERC721TokenCodec = t.interface({
    type: exports.ERC721TokenTypeT,
    data: t.interface({
        tokenId: io_ts_types_1.NonEmptyString,
        tokenAddress: exports.EthAddress,
    }),
});
var MintableERC20TokenType;
(function (MintableERC20TokenType) {
    MintableERC20TokenType["MINTABLE_ERC20"] = "MINTABLE_ERC20";
})(MintableERC20TokenType = exports.MintableERC20TokenType || (exports.MintableERC20TokenType = {}));
exports.MintableERC20TokenTypeT = fromEnum('MintableERC20TokenType', MintableERC20TokenType);
exports.MintableERC20TokenCodec = t.interface({
    type: exports.MintableERC20TokenTypeT,
    data: t.interface({
        id: t.string,
        blueprint: t.string,
        tokenAddress: t.union([t.string, exports.EthAddress]),
    }),
});
var MintableERC721TokenType;
(function (MintableERC721TokenType) {
    MintableERC721TokenType["MINTABLE_ERC721"] = "MINTABLE_ERC721";
})(MintableERC721TokenType = exports.MintableERC721TokenType || (exports.MintableERC721TokenType = {}));
exports.MintableERC721TokenTypeT = fromEnum('MintableERC721TokenType', MintableERC721TokenType);
exports.MintableERC721TokenCodec = t.interface({
    type: exports.MintableERC721TokenTypeT,
    data: t.interface({
        id: t.string,
        blueprint: t.string,
        tokenAddress: t.union([t.string, exports.EthAddress]),
    }),
});
exports.TokenTypeCodec = t.union([
    exports.ERC721TokenTypeT,
    exports.ETHTokenTypeT,
    exports.MintableERC20TokenTypeT,
    exports.MintableERC721TokenTypeT,
]);
exports.TokenCodec = t.union([
    exports.ETHTokenCodec,
    exports.ERC20TokenCodec,
    exports.ERC721TokenCodec,
    exports.MintableERC20TokenCodec,
    exports.MintableERC721TokenCodec,
]);
exports.MintBodyCodec = t.interface({
    etherKey: exports.EthAddress,
    tokens: t.array(exports.MintableERC721TokenCodec),
    nonce: exports.PositiveIntegerStringC,
    authSignature: t.string,
});
exports.MintFeeCodec = t.interface({
    address: exports.EthAddress,
    feePercentage: exports.PositiveIntegerC,
});
exports.MintUserCodec = t.interface({
    etherKey: exports.EthAddress,
    fees: t.array(exports.MintFeeCodec),
    tokens: t.array(exports.MintableERC721TokenCodec),
});
// TODO: remove V2 label when V1 is deprecated
exports.MintV2BodyCodec = t.interface({
    users: t.array(exports.MintUserCodec),
    contractAddress: exports.EthAddress,
    nonce: exports.PositiveIntegerStringC,
    authSignature: t.string,
});
exports.BigNumberCodec = t.type({
    vaultId: t.Int,
    token: exports.TokenCodec,
    quantity: t.bigint,
});
exports.BigNumberT = new t.Type('BigNumberT', function (u) { return u instanceof bignumber_1.BigNumber; }, function (u, c) {
    return function_1.pipe(E.tryCatch(function () { return bignumber_1.BigNumber.from(u); }, function (e) { return e; }), E.fold(function () { return t.failure(u, c); }, t.success));
}, t.identity);
exports.PositiveBigNumber = t.brand(exports.BigNumberT, function (s) { return s > bignumber_1.BigNumber.from(0); }, 'PositiveBigNumber');
exports.NonNegativeBigNumber = t.brand(exports.BigNumberT, function (s) { return s >= bignumber_1.BigNumber.from(0); }, 'NonNegativeBigNumber');
/**
 * Transfer / Order Params
 */
exports.TransferParamsCodec = t.interface({
    starkPublicKey: exports.HexadecimalString,
    vaultId: t.Int,
});
exports.OrderParamsCodec = t.interface({
    vaultId: t.Int,
    token: exports.TokenCodec,
    quantity: exports.PositiveBigNumber,
});
