"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkResultsCodecs = exports.LinkParamsCodecs = exports.FlatTokenWithAmountCodec = exports.FlatTokenCodec = void 0;
var t = __importStar(require("io-ts"));
var io_ts_types_1 = require("io-ts-types");
var _1 = require(".");
var FlatETHTokenCodec = t.interface({
    type: _1.ETHTokenTypeT,
});
var FlatETHTokenWithAmountCodec = t.intersection([FlatETHTokenCodec, t.interface({ amount: _1.PositiveNumberStringC })]);
var FlatERC721TokenCodec = t.interface({
    type: _1.ERC721TokenTypeT,
    tokenId: io_ts_types_1.NonEmptyString,
    tokenAddress: _1.EthAddress,
});
var FlatERC20TokenCodec = t.interface({
    type: _1.ERC20TokenTypeT,
    tokenAddress: _1.EthAddress,
    symbol: t.string,
});
var FlatERC20TokenWithAmountCodec = t.intersection([
    FlatERC20TokenCodec,
    t.interface({ amount: _1.PositiveNumberStringC }),
]);
exports.FlatTokenCodec = t.union([FlatETHTokenCodec, FlatERC721TokenCodec, FlatERC20TokenCodec]);
exports.FlatTokenWithAmountCodec = t.union([
    FlatETHTokenWithAmountCodec,
    FlatERC721TokenCodec,
    FlatERC20TokenWithAmountCodec,
]);
var TransferParamsCodec = t.intersection([
    exports.FlatTokenWithAmountCodec,
    t.interface({
        to: _1.EthAddress,
    }),
]);
var BuyParamsCodec = t.interface({
    orderId: _1.PositiveNumberStringC,
});
var BuyV2ParamsCodec = t.interface({
    orderIds: t.array(_1.PositiveNumberStringC),
});
var SellParamsCodec = t.interface({
    amount: _1.PositiveNumberStringC,
    tokenId: io_ts_types_1.NonEmptyString,
    tokenAddress: _1.EthAddress,
});
var CancelParamsCodec = t.interface({
    orderId: _1.PositiveNumberStringC,
});
var LinkParamsCodecs;
(function (LinkParamsCodecs) {
    LinkParamsCodecs.Setup = t.interface({});
    LinkParamsCodecs.History = t.interface({});
    LinkParamsCodecs.Buy = BuyParamsCodec;
    LinkParamsCodecs.BuyV2 = BuyV2ParamsCodec;
    LinkParamsCodecs.CompleteWithdrawal = exports.FlatTokenCodec;
    LinkParamsCodecs.Deposit = exports.FlatTokenWithAmountCodec;
    LinkParamsCodecs.PrepareWithdrawal = exports.FlatTokenWithAmountCodec;
    LinkParamsCodecs.Sell = SellParamsCodec;
    LinkParamsCodecs.Transfer = TransferParamsCodec;
    LinkParamsCodecs.Cancel = CancelParamsCodec;
})(LinkParamsCodecs = exports.LinkParamsCodecs || (exports.LinkParamsCodecs = {}));
var SuccessOrError = t.union([t.literal('success'), t.literal('error')]);
var BuV2ResultsCodec = t.interface({
    result: t.record(_1.PositiveNumberStringC, t.type({ status: SuccessOrError, message: SuccessOrError })),
});
var SetupResultsCodec = t.interface({
    address: _1.EthAddress,
    starkPublicKey: _1.HexadecimalString,
});
var PrepareWithdrawalCodec = t.interface({
    withdrawalId: t.Int,
});
var CompleteWithdrawalCodec = t.interface({
    transactionId: t.string,
});
var LinkResultsCodecs;
(function (LinkResultsCodecs) {
    LinkResultsCodecs.Setup = SetupResultsCodec;
    LinkResultsCodecs.BuyV2 = BuV2ResultsCodec;
    LinkResultsCodecs.PrepareWithdrawal = PrepareWithdrawalCodec;
    LinkResultsCodecs.CompleteWithdrawal = CompleteWithdrawalCodec;
})(LinkResultsCodecs = exports.LinkResultsCodecs || (exports.LinkResultsCodecs = {}));
